package com.bcxin.tenant.open.domains.repositories;

import com.baomidou.mybatisplus.core.conditions.query.LambdaQueryWrapper;
import com.bcxin.tenant.open.domains.entities.StationDeviceEntity;
import com.bcxin.tenant.open.domains.mappers.StationDeviceMapper;
import org.springframework.stereotype.Repository;
import org.springframework.util.CollectionUtils;

import java.io.Serializable;
import java.util.Collection;
import java.util.Collections;

@Repository
public class StationDeviceRepositoryImpl implements StationDeviceRepository{
    private final StationDeviceMapper mapper;

    public StationDeviceRepositoryImpl(StationDeviceMapper mapper) {
        this.mapper = mapper;
    }

    @Override
    public StationDeviceEntity getById(Object id) {
        return this.mapper.selectById((Serializable) id);
    }

    @Override
    public void insert(StationDeviceEntity data) {
        this.mapper.insert(data);
    }

    @Override
    public void update(StationDeviceEntity data) {
        this.mapper.updateById(data);
    }

    @Override
    public Collection<StationDeviceEntity> getByStationIds(Collection<String> stationIds) {
        if (CollectionUtils.isEmpty(stationIds)) {
            return Collections.EMPTY_LIST;
        }

        LambdaQueryWrapper<StationDeviceEntity> lambdaQueryWrapper = new LambdaQueryWrapper<>();
        lambdaQueryWrapper.in(StationDeviceEntity::getStationId, stationIds);
        return this.mapper.selectList(lambdaQueryWrapper);
    }
}
